/*****************************************************************************
 * Copyright (c) 2016 CEA LIST and others.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Mickael ADAM (ALL4TEC) mickael.adam@all4tec.net - Initial API and Implementation
 *****************************************************************************/

package org.eclipse.papyrus.infra.gmfdiag.paletteconfiguration;

/**
 * Identifier used to distinct resources on a resource set used to edit palette configuration.
 */
public class PaletteRessourcesConstants {
	/** The identifier for semantic element type resource. */
	public static final String PALETTE_RESSOURCE_IDENTIFIER = "resourcePalette"; //$NON-NLS-1$

	/** The identifier for semantic element type resource. */
	public static final String ELEMENTTYPE_SEMENTIC_RESSOURCE_IDENTIFIER = "resourceElementTypeSemantic"; //$NON-NLS-1$

	/** The identifier for ui element type resource. */
	public static final String ELEMENTTYPE_UI_RESSOURCE_IDENTIFIER = "resourceElementTypeUI";//$NON-NLS-1$

	/** The identifier for assistant resource. */
	public static final String ASSISTANT_RESSOURCE_IDENTIFIER = "resourceAssistant";//$NON-NLS-1$

	/** The identifier for new child resource. */
	public static final String NIEW_CHILD_RESSOURCE_IDENTIFIER = "resourceNewChild";//$NON-NLS-1$
}

